#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
using namespace std;

const int DIM = 6;

enum Casella {VUOTA, MINA, ESPLORATA_VUOTA, ESPLORATA_MINA};

struct CampoMinato {
  int mosse;
  Casella campo[DIM][DIM];
};


void inizializza(CampoMinato* pm, int num);
bool vicinoMina(const CampoMinato* pm, int x, int y);
void stampa(const CampoMinato* pm);
bool caricaPartita(CampoMinato* pm, const char nomef[]);
int suggerimento(const CampoMinato* pm, int vett[]);

bool click(CampoMinato* pm, int x, int y) {
  pm->mosse++;
  if(pm->campo[x][y] == VUOTA || pm->campo[x][y] == ESPLORATA_VUOTA) {
    pm->campo[x][y] = ESPLORATA_VUOTA;
    return true;
  } else {
    pm->campo[x][y] = ESPLORATA_MINA;
    return false;
  }
}

void menu(){
  cout << endl << "-----------------" << endl;
  cout << "1) inizializza" << endl;
  cout << "2) click" << endl;
  cout << "3) stampa" << endl;
  cout << "4) carica" << endl;
  cout << "5) suggerimento" << endl;
  cout << "6) vicino mina" << endl;
  cout << "7) esci" << endl;
  cout << "? ";
}

int main(){
  CampoMinato cm;
  char c;  
  int m, x, y;
  int vv[DIM];

  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        cout << "Quante mine? ";
        cin >> m;
        inizializza(&cm, m);
        break;
      case '2':
        cout << "Inserisci le coordinate:" << endl;
        cout << "x? ";
        cin >> x; 
        cout << "y? ";
        cin >> y;
        if(click(&cm, x, y)) cout << "Ti e' andata bene!" << endl;
        else cout << "BOOOM! Sei esploso." << endl;
        break;
      case '3':
        stampa(&cm);
        break;
      case '4':
        if(caricaPartita(&cm, "input.txt")) cout << "Ho caricato la partita" << endl;
        else cout << "Problemi nel caricamento" << endl;
        break;
      case '5':
        m = suggerimento(&cm, vv);
        cout << "Le seguenti colonne contengono mine:" << endl;
        for(int i=0; i<m; i++)
          cout << vv[i] << " ";
        cout << endl;
        break;
      case '6':
        cout << "Inserisci le coordinate:" << endl;
        cout << "x? ";
        cin >> x;
        cout << "y? ";
        cin >> y;
        if(vicinoMina(&cm, x, y)) cout << "E' vicino a una mina" << endl;
        else cout << "Non e' vicino a una mina" << endl; 
        break;
      case '7':
        return 0;
    }
  }
}
